HonorGoldEnabled = true --this is a saved variable per char
local update_time = 0.1

local HonorGold = CreateFrame("Frame")
HonorGold:RegisterEvent("ADDON_LOADED")
HonorGold:RegisterEvent("MERCHANT_SHOW")
HonorGold:RegisterEvent("MERCHANT_CLOSED")
HonorGold:RegisterEvent("BANKFRAME_OPENED")
HonorGold:RegisterEvent("BANKFRAME_CLOSED")

local floor = floor
local select = select
local BuyMerchantItem = BuyMerchantItem
local ContainerRefundItemPurchase = ContainerRefundItemPurchase
local GetContainerItemPurchaseInfo = GetContainerItemPurchaseInfo
local GetContainerNumSlots = GetContainerNumSlots
local GetMerchantItemLink = GetMerchantItemLink
local GetMerchantNumItems = GetMerchantNumItems
local UseContainerItem = UseContainerItem
local StaticPopup1Button1 = StaticPopup1Button1

local money
local need_to_close
local vendor_item_index
local merchand_open
local bank_open
local dagger_merchant = {["12784"] = true,["12794"] = true,["40212"] = true,["40216"] = true}
local is_dagger_merchant

local loop_bags
local Sell_Script
local Buy_Script
local Regret_Script
local display_gold_earned
local HonorGoldCommand 
local OnEvent

OnEvent = function(self,event,...)
	if event=="ADDON_LOADED" and ...=="HonorGold" then
		if HonorGoldEnabled then
			HonorGold:SetScript("OnEvent",OnEvent)
		else
			HonorGold:SetScript("OnEvent",nil)
		end
	elseif event=="MERCHANT_SHOW" then
		merchand_open = true
		local merchant_guid = UnitGUID("target")
		is_dagger_merchant = dagger_merchant[select(6,strsplit('-',merchant_guid))]
		local items_to_sell
		items_to_sell,money = loop_bags(0,4,"count")
		if items_to_sell then
			self:SetScript("OnUpdate",Sell_Script)
		elseif UnitLevel("player")>=70 and is_dagger_merchant then
			vendor_item_index = nil
			if floor(select(2,GetCurrencyInfo(392))/105)>0 then
				self:SetScript("OnUpdate",Buy_Script)
			end
		end
	elseif event=="MERCHANT_CLOSED" then
		merchand_open = false
		self:SetScript("OnUpdate",nil)
	elseif event=="BANKFRAME_OPENED" then
		bank_open = true
		loop_bags(5,11,"withdraw_ready")
		loop_bags(-1,-1,"withdraw_ready")
	elseif event=="BANKFRAME_CLOSED" then
		bank_open = false
		self:SetScript("OnUpdate",nil)
	end
end
HonorGold:SetScript("OnEvent",OnEvent)

Sell_Script = function(self,elapsed)
	self.timer = self.timer and self.timer+elapsed or 0
	if self.timer>update_time then
		self.timer = 0
		if not loop_bags(0,4,"sell") then
			self:SetScript("OnUpdate",nil)
			display_gold_earned(money)
			if UnitLevel("player")>=70 and is_dagger_merchant then
				vendor_item_index = nil
				if floor(select(2,GetCurrencyInfo(392))/105)>0 then
					self:SetScript("OnUpdate",Buy_Script)
				end
			end
		end
	end
end

Buy_Script = function(self,elapsed)
	self.timer = self.timer and self.timer+elapsed or 0
	if self.timer>update_time then
		self.timer = 0
		MerchantFrame_SetFilter(MerchantFrame,1)
		local i = 1
		local link
		while not vendor_item_index and i<=GetMerchantNumItems() do
			link = GetMerchantItemLink(i)
			if link and link:match("item:(%d+)")=="35058" then
				vendor_item_index = i
			else
				i = i+1
			end
		end
		if vendor_item_index then
			local n = floor(select(2,GetCurrencyInfo(392))/105)
			if n>0 then
				BuyMerchantItem(vendor_item_index)
				StaticPopup1Button1:Click()
			else
				CloseMerchant()
				self:SetScript("OnUpdate",nil)
			end
		end
		UIErrorsFrame:Clear()
	end
end

Regret_Script = function(self,elapsed)
	self.timer = self.timer and self.timer+elapsed or 0
	if self.timer>update_time then
		self.timer = 0
		if not loop_bags(0,4,"regret") then
			HonorGold:SetScript("OnUpdate",nil)
		end
	end
end

display_gold_earned = function(money)
	local g,s,c,text
	g = floor(money/10000)
	s = floor((money-g*10000)/100)
	c = mod(money,100)
	text = ""
	if g>0 then
		text = g.." gold"
	end
	if s>0 then
		text = text.." "..s.." silver"
	end
	if c>0 then
		text = text.." "..c.." copper"
	end
	text = text.."."
	DEFAULT_CHAT_FRAME:AddMessage("HonorGold: You received "..text,0,1,0)
end

loop_bags = function(bag_min,bag_max,what_for)
	local return_value1
	local return_value2
	local link
	for bag=bag_min,bag_max do
		local n = GetContainerNumSlots(bag)
		if n then
			for slot=1,n do
				link = GetContainerItemLink(bag,slot)
				if link and link:match("item:(%d+)")=="35058" then
					if what_for=="count" then
						if GetContainerItemPurchaseInfo(bag,slot)==nil then
							return_value1 = true
							return_value2 = return_value2 and return_value2+160738 or 160738
						end
					elseif what_for=="sell" then
						if GetContainerItemPurchaseInfo(bag,slot)==nil then
							UseContainerItem(bag,slot)
							return_value1 = true
						end
					elseif what_for=="regret" then
						if GetContainerItemPurchaseInfo(bag,slot)~=nil then
							ContainerRefundItemPurchase(bag,slot)
							StaticPopup1Button1:Click()
							return_value1 = true
						end
					elseif what_for=="deposit" then
						if GetContainerItemPurchaseInfo(bag,slot)~=nil then
							UseContainerItem(bag,slot)
						end
					elseif what_for=="withdraw_ready" then
						if GetContainerItemPurchaseInfo(bag,slot)==nil then
							UseContainerItem(bag,slot)
						end
					elseif what_for=="withdraw_all" then
						UseContainerItem(bag,slot)
					end
				end
			end
		end
	end
	UIErrorsFrame:Clear()
	return return_value1,return_value2
end

HonorGoldCommand = function(msg)
	if msg=="" then
		if not HonorGoldEnabled then
			HonorGoldEnabled = true
			HonorGold:SetScript("OnEvent",OnEvent)
			DEFAULT_CHAT_FRAME:AddMessage("HonorGold enabled.",0,1,0)
		else
			HonorGoldEnabled = false
			HonorGold:SetScript("OnEvent",nil)
			HonorGold:SetScript("OnUpdate",nil)
			DEFAULT_CHAT_FRAME:AddMessage("HonorGold disabled.",1,0,0)
		end
	elseif string.upper(msg)=="DEPOSIT" then
		if bank_open then
			loop_bags(0,4,"deposit")
		end
	elseif string.upper(msg)=="WITHDRAW" then
		if bank_open then
			loop_bags(-1,-1,"withdraw_all")
			loop_bags(5,11,"withdraw_all")
		end
	elseif string.upper(msg)=="REGRET" then
		if merchand_open then
			HonorGold:SetScript("OnUpdate",Regret_Script)
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("HonorGold: Command not found.",1,0,0)
	end
end

SlashCmdList["HonorGold"] = HonorGoldCommand
SLASH_HonorGold1 = "/honorgold"